/**
**************************************************************************************************
* @file		hardwareDescription.h
* @author		Kerem Yollu & Edwin Koch
* @date		19.12.2021
* @version	1.0
************************************************************************************************** 
* @brief		This file contains all hardware specific definitions for STM32F042K6
* 
* **Detailed Description :**
* This Header file contains all the registers and their bit manipulation options. 
* All the extra Tables created here are to somplifly the main codes readability 
*
* @todo 
*	- 19.12.2021 : implement until it runs :) 
**************************************************************************************************
*/

#ifndef _hardwareDescription_H_
#define _hardwareDescription_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "stm32f042x6.h"
#include <stdint.h>

#define PACKAGE_LQFP32 1

#define MAX_I2S_CHANNEL_COUNT 2
#define MAX_CAN_CHANNEL_COUNT 1



/*! 
 * Enum for awailable clok sources RM Page: 95 
 * */
typedef enum { 
	CLK_HSI,	/*!< High speed internal */ 
	CLK_HSE,	/*!< High speed external */
	CLK_LSI,	/*!< Low speed internal */
	CLK_LSE		/*!< Low speed External */
}clkSources_t;

 
#ifdef __cplusplus
}
#endif

#endif // _hardwareDescription_H_
