####################################################################################################
# DOXYGEN
####################################################################################################

function(generateDoxygen)
if(OUTPUT_DOXYGEN)
	find_package(Doxygen)
	if (DOXYGEN_FOUND)
		set(DOXYGEN_IN ${CMAKE_CORE_DIR}/doxyfile.in)
		set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/doxyfile)
		message("${Green}")
		message("+-------------------------------+")
		message("Generating Doxygen output")
		message("+-------------------------------+")
		message("${ColourReset}")

		# request to configure the file
		configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT} @ONLY)
		# note the option ALL which allows to build the docs together with the application
		add_custom_target( doc_doxygen ALL
			COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
			WORKING_DIRECTORY ${DOXYGEN_OUTPUT_DIR}
			COMMENT "Generating API documentation with Doxygen"
			VERBATIM )
	else (DOXYGEN_FOUND)
		message("Doxygen need to be installed to generate the doxygen documentation")
	endif (DOXYGEN_FOUND)
endif(OUTPUT_DOXYGEN)
endfunction()
